Initial version.
[udpkey] / debian / udpkey.init
CommitLineData
247f344a
MW
1#! /bin/sh
2### BEGIN INIT INFO
3# Provides: udpkey
4# Required-Start: $remote_fs $syslog
5# Required-Stop: $remote_fs $syslog
6# Default-Start: 2 3 4 5
7# Default-Stop: 0 1 6
8# Short-Description: Provide boot keys to remote systems
9### END INIT INFO
10
11# Author: Mark Wooding <mdw@distorted.org.uk>
12
13# PATH should only include /usr/* if it runs after the mountnfs.sh script
14PATH=/sbin:/usr/sbin:/bin:/usr/bin
15DESC="Boot key daemon"
16NAME=udpkey
17DAEMON=/usr/bin/$NAME
18PORT=59274
19PIDFILE=/var/run/$NAME.pid
20USER=udpkey
21DAEMON_ARGS="-ld -k/etc/udpkey/keyring -p$PIDFILE"
22SCRIPTNAME=/etc/init.d/$NAME
23UDPKEY_DAEMON=no
24
25# Exit if the package is not installed
26[ -x "$DAEMON" ] || exit 0
27
28# Read configuration variable file if it is present
29[ -r /etc/default/$NAME ] && . /etc/default/$NAME
30case $UDPKEY_DAEMON in yes) ;; *) exit 0 ;; esac
31
32# Load the VERBOSE setting and other rcS variables
33. /lib/init/vars.sh
34
35# Define LSB log_* functions.
36# Depend on lsb-base (>= 3.2-14) to ensure that this file is present
37# and status_of_proc is working.
38. /lib/lsb/init-functions
39
40#
41# Function that starts the daemon/service
42#
43do_start()
44{
45 # Return
46 # 0 if daemon has been started
47 # 1 if daemon was already running
48 # 2 if daemon could not be started
49 start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON --test > /dev/null \
50 || return 1
51 touch $PIDFILE; chown $USER $PIDFILE
52 start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON --chuid $USER -- \
53 $DAEMON_ARGS $PORT \
54 || return 2
55}
56
57#
58# Function that stops the daemon/service
59#
60do_stop()
61{
62 # Return
63 # 0 if daemon has been stopped
64 # 1 if daemon was already stopped
65 # 2 if daemon could not be stopped
66 # other if a failure occurred
67 start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --pidfile $PIDFILE --name $NAME
68 RETVAL="$?"
69 [ "$RETVAL" = 2 ] && return 2
70 # Wait for children to finish too if this is a daemon that forks
71 # and if the daemon is only ever run from this initscript.
72 # If the above conditions are not satisfied then add some other code
73 # that waits for the process to drop all resources that could be
74 # needed by services started subsequently. A last resort is to
75 # sleep for some time.
76 start-stop-daemon --stop --quiet --oknodo --retry=0/30/KILL/5 --exec $DAEMON
77 [ "$?" = 2 ] && return 2
78 # Many daemons don't delete their pidfiles when they exit.
79 rm -f $PIDFILE
80 return "$RETVAL"
81}
82
83case "$1" in
84 start)
85 [ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC" "$NAME"
86 do_start
87 case "$?" in
88 0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
89 2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
90 esac
91 ;;
92 stop)
93 [ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME"
94 do_stop
95 case "$?" in
96 0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
97 2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
98 esac
99 ;;
100 status)
101 status_of_proc "$DAEMON" "$NAME" && exit 0 || exit $?
102 ;;
103 restart|force-reload)
104 log_daemon_msg "Restarting $DESC" "$NAME"
105 do_stop
106 case "$?" in
107 0|1)
108 do_start
109 case "$?" in
110 0) log_end_msg 0 ;;
111 1) log_end_msg 1 ;; # Old process is still running
112 *) log_end_msg 1 ;; # Failed to start
113 esac
114 ;;
115 *)
116 # Failed to stop
117 log_end_msg 1
118 ;;
119 esac
120 ;;
121 *)
122 echo "Usage: $SCRIPTNAME {start|stop|status|restart|force-reload}" >&2
123 exit 3
124 ;;
125esac
126
127: